/*--------------------------
	include
--------------------------*/
#define _INC_OLE
#include <windows.h>
#undef	_INC_OLE
#include <shlobj.h>

#include "resource.h"
#include "OleDragDrop.h"

/*--------------------------
	define
--------------------------*/
#define BUF_SIZE		256

#define CF_CNT			2

#define WM_DRAGDROP		(WM_APP + 100)
#define WM_GETDATA		(WM_APP + 101)

/*--------------------------
	function
--------------------------*/

/* hbvt@C̍쐬 */
static HDROP APIPRIVATE CreateDropFileMem(char **FileName,int cnt,BOOL fWide)
{
	HDROP hDrop;
	LPDROPFILES lpDropFile;
	wchar_t wbuf[BUF_SIZE];
	int flen = 0;
	int i;
	
	if(fWide == TRUE){
		/* ChL */
		for(i = 0;i < cnt;i++){
			MultiByteToWideChar(CP_ACP,0,FileName[i],-1,wbuf,BUF_SIZE);
			flen += (wcslen(wbuf) + 1) * sizeof(wchar_t);
		}
		flen++;
	}else{
		/* }`oCg */
		for(i = 0;i < cnt;i++){
			flen += lstrlen(FileName[i]) + 1;
		}
	}

	hDrop = (HDROP)GlobalAlloc(GHND,sizeof(DROPFILES) + flen + 1);
	if (hDrop == NULL){
		return NULL;
	}

	lpDropFile = (LPDROPFILES) GlobalLock(hDrop);
	lpDropFile->pFiles = sizeof(DROPFILES);		/* t@C̃Xg܂ł̃ItZbg */
	lpDropFile->pt.x = 0;
	lpDropFile->pt.y = 0;
	lpDropFile->fNC = FALSE;
	lpDropFile->fWide = fWide;					/* ChL̏ꍇ TRUE */

	/* \̂̌Ƀt@C̃XgRs[B(t@C\0t@C\0t@C\0\0) */
	if(fWide == TRUE){
		/* ChL */
		wchar_t *buf;

		buf = (wchar_t *)(&lpDropFile[1]);
		for(i = 0;i < cnt;i++){
			MultiByteToWideChar(CP_ACP,0,FileName[i],-1,wbuf,BUF_SIZE);
			wcscpy(buf,wbuf);
			buf += wcslen(wbuf) + 1;
		}
	}else{
		/* }`oCg */
		char *buf;

		buf = (char *)(&lpDropFile[1]);
		for(i = 0;i < cnt;i++){
			lstrcpy(buf,FileName[i]);
			buf += lstrlen(FileName[i]) + 1;
		}
	}

	GlobalUnlock(hDrop);
	return(hDrop);
}


BOOL CALLBACK MainProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LPIDROPTARGET_NOTIFY pdtn;
	UINT cf[CF_CNT];
	POINT pt;
	HWND mWnd;
	char buf[BUF_SIZE],*p;
	int i,j,len;

	static UINT gcf;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		/* hbO^[Qbg̓o^ */
		/* CF_XXXX w肷邩ARegisterClipboardFormat() œo^Ǝ`w肵܂B */
		/* w肷邱ƂłAz̗vf̐擪D揇ʏɂȂĂ܂B */
		cf[0] = CF_TEXT;	/* eLXg */
		cf[1] = CF_HDROP;	/* t@C */
		if(OLE_IDropTarget_RegisterDragDrop(hDlg, WM_DRAGDROP,cf,CF_CNT) == FALSE){
			MessageBox(hDlg,"hbv^[Qbg̓o^Ɏs܂B","Error",MB_OK | MB_ICONERROR);
			EndDialog(hDlg, FALSE);
		}

		SendMessage(GetDlgItem(hDlg,IDC_EDIT_DROPTEXT),WM_SETTEXT,0,(LPARAM)"hbOhbv Tv");
		break;

	case WM_CLOSE:
		OLE_IDropTarget_RevokeDragDrop(hDlg);

		EndDialog(hDlg, FALSE);
		break;

	case WM_SETCURSOR:
		if((HWND)wParam == GetDlgItem(hDlg,IDC_BUTTON_TEST) && HIWORD(lParam) == WM_LBUTTONDOWN){
			/* hbO&hbv̊Jn */
			/* CF_XXXX w肷邩ARegisterClipboardFormat() œo^Ǝ`w肵܂B */
			/* w肷邱Ƃł܂BD揇ʂ͂܂B */
			cf[0] = CF_TEXT;
			/* 5Ԗڂ̃GtFNgɎw肵̂ݍs܂B */
			if(OLE_IDropSource_Start(hDlg,WM_GETDATA,cf,1,DROPEFFECT_COPY) == DROPEFFECT_MOVE){
				/*  Drop  5 DROPEFFECT_MOVE w肵Ă ߂l DROPEFFECT_MOVE ̏ꍇ́AړꂽsB */
				/* Ⴆ΃eLXg̏ꍇ̓eLXg̍폜ȂǁBBB */
			}

		}else if((HWND)wParam == GetDlgItem(hDlg,IDC_LIST_FILE) && HIWORD(lParam) == WM_LBUTTONDOWN){
			if(SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_GETSELCOUNT,0,0) == 0){
				return(FALSE);
			}

			/* hbO&hbv̊Jn */
			cf[0] = CF_HDROP;
			if(OLE_IDropSource_Start(hDlg,WM_GETDATA,cf,1,DROPEFFECT_COPY | DROPEFFECT_MOVE | DROPEFFECT_LINK) == DROPEFFECT_MOVE){
				/* DROPEFFECT_MOVE ̏ꍇXg{bNX̑IĂ鍀ڂ폜B */
				for(i = SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_GETCOUNT,0,0);i >= 0 ;i--){
					if(SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_GETSEL,i,0) == 0){
						continue;
					}
					SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_DELETESTRING,i,0);
				}
			}

		}else{
			return(FALSE);
		}

		GetCursorPos(&pt);
		PostMessage((HWND)wParam,WM_LBUTTONUP,0,MAKELPARAM(pt.x,pt.y));
		break;

	case WM_DRAGDROP:
		pdtn = (LPIDROPTARGET_NOTIFY)lParam;

		switch(wParam){
		case IDROPTARGET_NOTIFY_DRAGENTER:	/* }EXEBhEɓĂƂ */
			gcf = pdtn->cfFormat;

		case IDROPTARGET_NOTIFY_DRAGOVER:	/* }EXEBhEňړƂ */
			/* }EẌʒũEBhEƃhbOĂf[^̃Nbv{[htH[}bgɂGtFNgωB */
			pt.x = pdtn->ppt->x;
			pt.y = pdtn->ppt->y;
			mWnd = WindowFromPoint(pt);
			
			if(gcf == CF_TEXT && mWnd == GetDlgItem(hDlg,IDC_EDIT_DROPTEXT)){
				/* Nbv{[htH[}bg CF_TEXT ŁA}EX EDIT ̏ɂƂ */
				pdtn->dwEffect = DROPEFFECT_COPY | DROPEFFECT_LINK;

			}else if(gcf == CF_HDROP && mWnd == GetDlgItem(hDlg,IDC_LIST_FILE)){
				/* Nbv{[htH[}bg CF_HDROP ŁA}EXXg{bNX̏ɂƂ */
				pdtn->dwEffect = DROPEFFECT_COPY;

			}else{
				pdtn->dwEffect = DROPEFFECT_NONE;
			}
			break;

		case IDROPTARGET_NOTIFY_DRAGLEAVE:	/* }EXEBhEoƂ */
			break;

		case IDROPTARGET_NOTIFY_DROP:		/* hbvꂽƂ */
			/* hbvꂽf[^ (pdtn->hMem) ̈͊{IɃNbv{[h̑ƓłB */
			switch(pdtn->cfFormat)
			{
			case CF_TEXT:			/* eLXg */
				SetForegroundWindow(hDlg);
				
				/* pdtn->hMem ̌^ HGLOBAL łB */
				p = GlobalLock(pdtn->hMem);
				if(p == NULL){
					break;
				}
				SendMessage(GetDlgItem(hDlg,IDC_EDIT_DROPTEXT),WM_SETTEXT,0,(LPARAM)p);
				GlobalUnlock(pdtn->hMem);
				break;

			case CF_HDROP:			/* t@C */
				SetForegroundWindow(hDlg);
				
				/* pdtn->hMem ̌^ HDROP łB */
				for(i = 0;i < (int)DragQueryFile(pdtn->hMem,0xFFFFFFFF,NULL,0);i++){
					DragQueryFile(pdtn->hMem,i,buf,BUF_SIZE - 1);
					
					if(SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_FINDSTRING,(WPARAM)-1,(LPARAM)buf) < 0){
						SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_ADDSTRING,0,(LPARAM)buf);
					}
				}

				break;

			default:
				break;
			}
			break;
		}
		break;

	case WM_GETDATA:
		/* hbvf[^͊{IɃNbv{[h̑ƓłB */
		switch(wParam)
		{
		case CF_TEXT:		/* eLXg */
			{
				HGLOBAL hMem;

				len = SendMessage(GetDlgItem(hDlg,IDC_EDIT_DROPTEXT),WM_GETTEXTLENGTH,0,0);
				SendMessage(GetDlgItem(hDlg,IDC_EDIT_DROPTEXT),WM_GETTEXT,len + 1,(LPARAM)buf);

				hMem = GlobalAlloc(GHND,len + 1);
				if(hMem == NULL){
					abort();
				}
				p = GlobalLock(hMem);
				lstrcpy(p,buf);
				GlobalUnlock(hMem);
				*((HANDLE *)lParam) = hMem;
			}
			break;

		case CF_HDROP:		/* t@C */
			{
				OSVERSIONINFO os_info;
				BOOL NTFlag = FALSE;
				char **FileNameList;
				
				/* t@C̔z쐬 */
				FileNameList = (char **)GlobalAlloc(GPTR,sizeof(char *) * SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_GETSELCOUNT,0,0));
				if(FileNameList == NULL){
					abort();
				}
				j = 0;
				for(i = 0;i < SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_GETCOUNT,0,0);i++){
					if(SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_GETSEL,i,0) == 0){
						continue;
					}
					len = SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_GETTEXTLEN,i,0);
					FileNameList[j] = (char *)GlobalAlloc(GPTR,len + 1);
					if(FileNameList[j] == NULL){
						abort();
					}
					SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_GETTEXT,i,(LPARAM)FileNameList[j]);
					j++;
				}
				
				os_info.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
				GetVersionEx(&os_info);
				if(os_info.dwPlatformId == VER_PLATFORM_WIN32_NT){
					NTFlag = TRUE;
				}

				/* hbvt@CXg̍쐬 */
				/* NT̏ꍇUNICODEɂȂ悤ɂ */
				*((HANDLE *)lParam) = CreateDropFileMem(FileNameList,SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_GETSELCOUNT,0,0),NTFlag);

				/* t@C̔z */
				for(i = 0;i < SendMessage(GetDlgItem(hDlg,IDC_LIST_FILE),LB_GETSELCOUNT,0,0);i++){
					GlobalFree(FileNameList[i]);
				}
				GlobalFree(FileNameList);
			}
			break;

		default:
			*((HANDLE *)lParam) = NULL;
			break;
		}
		break;

	default:
		return(FALSE);
	}
	return(TRUE);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	/* OLȄs܂B */
	if(OleInitialize(NULL) != S_OK){
		MessageBox(NULL,"OLȄɎs܂B","Error",MB_OK | MB_ICONERROR);
		return 0;
	}

	if(DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG_MAIN),NULL,MainProc) == TRUE){
	}

	OleUninitialize();

	return 0;
}

/* End of source */